Cdecl99 is a tool to help construct or understand complicated C declarations.
Inspired by the venerable cdecl, which predates C's standardization in 1989,
cdecl99 implements more or less the same concept but for modern C.

Unlike the original cdecl, cdecl99 supports all relevant C99 keywords, has no
undue restrictions on identifiers, understands features such as complex types,
variadic functions and named parameters, and also has the ability to parse
"plain" type names (which do not declare an identifier).

At this time there is no support for new declaration syntax introduced in C11,
including atomic types, `_Alignas`, `_Thread_local` or `_Noreturn` specifers.

The package includes both an executable program (cdecl99) and a library
(libcdecl) which can be used by other programs to provide cdecl-like
functionality.

# Prerequisites

Cdecl99 is writtin in C, so a working C compiler is required.  Certain
optional features depend on the use of external libraries.  In particular,

* the [GNU Readline library][readline-homepage] is needed for
  interactive line-editing and history functionality, and

* the [GNU libintl library][gettext-homepage] (included with the GNU C
  library) is needed in order to support localized program messages.
  However, the core functionality of translating C declarations to/from
  pseudo-English is not localizable.

[readline-homepage]: https://www.gnu.org/software/readline/
[gettext-homepage]: https://www.gnu.org/software/gettext/

# Contributing

Please send suggestions, bug reports, patches or any other
correspondence regarding cdecl99 by electronic mail to
[Nick Bowler \<nbowler@draconx.ca\>][email].

[email]: mailto:nbowler@draconx.ca

# License

Cdecl99 is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation, either version 3 of the License or (at your option) any later
version.

{::comment}
Copyright © 2011, 2019, 2021 Nick Bowler
{:/comment}
